Links

- Docs Home
- Config Ref. Home

Top Level Elements

- Server
- Service

Connectors

- General Intro
- HTTP
- AJP

Containers

- Context
- Engine
- Host

Nested Components

- Default Context
- Global Resources
- Loader
- Logger
- Manager
- Realm
- Resources
- Valve

# Server Configuration Reference

## The AJP Connector

print-friendly
version

Introduction

> The AJP Connector element represents a Connector component that communicates with a web connector via the `AJP` protocol. This is used for cases where you wish to invisibly integrate Tomcat 5 into an existing (or new) Apache installation, and you want Apache to handle the static content contained in the web application, and/or utilize Apache's SSL processing.

> This connector supports load balancing when used in conjunction with the `jvmRoute` attribute of the Engine.

Attributes

> Common Attributes

> > All implementations of Connector support the following attributes:

> > Attribute | Description
> > --- | ---
> > `address` | For servers with more than one IP address, this attribute specifies which address will be used for listening on the specified port. By default, this port will be used on all IP addresses associated with the server. A value of `127.0.0.1` indicates that the Connector will only listen on the loopback interface.
> > `allowTrace` | A boolean value which can be used to enable or disable the TRACE HTTP method. If not specified, this attribute is set to false.
> > `enableLookups` | Set to `true` if you want calls to `request.getRemoteHost()` to perform DNS lookups in order to return the actual host name of the remote client. Set to `false` to skip the DNS lookup and return the IP address in String form instead (thereby improving performance). By default, DNS lookups are enabled.
> > `maxPostSize` | The maximum size in bytes of the POST which will be handled by the container FORM URL parameter parsing. The feature can be disbled by setting this attribute to a value inferior or equal to 0. If not specified, this attribute is set to 2097152 (2 megabytes).
> > `minProcessors` | The minimum number of processors to start at initialization time. If not specified, this attribute is set to 5.

> > `maxProcessors`

> > The maximum number of processors allowed. This should be set to a value that is greater than or equal to the maximum number of concurrent connections the remote web server can open to Tomcat simultaneously. For example, if the web server is Apache 1.x or 2.x Tomcat's `maxProcessors` should be set to the value of Apache's `maxClients` directive.

> > A `maxProcessors` value of zero (0) signifies that the number of processors is unlimited. If not specified, this atttribute defaults to 20.

> > `redirectPort` | If this Connector is supporting non-SSL requests, and a request is received for which a matching `<security-constraint>` requires SSL transport, Catalina will automatically redirect the request to the port number specified here.
> > `scheme` | Set this attribute to the name of the protocol you wish to have returned by calls to `request.getScheme()`. For example, you would set this attribute to "`https`" for an SSL Connector. The default value is "`http`".
> > `secure` | Set this attribute to `true` if you wish to have calls to `request.isSecure()` to return `true` for requests received by this Connector (you would want this on an SSL Connector). The default value is `false`.
> > `URIEncoding` | This specifies the character encoding used to decode the URI bytes, after %xx decoding the URL. If not specified, ISO-8859-1 will be used.

> > `useBodyEncodingForURI`

> > This specifies if the encoding specified in contentType should be used for URI query parameters, instead of using the URIEncoding. This setting is present for compatibility with Tomcat 4.1.x, where the encoding specified in the contentType, or explicitely set using Request.setCharacterEncoding method was also used for the parameters from the URL. The default value is `false`.

> Standard Implementation

> > The standard implementation of AJP Connector is org.apache.coyote.tomcat5.CoyoteConnector, but you must specify the protocol attribute (see below).

> > This implementation supports the AJP 1.3 protocol.

> > It supports the following additional attributes (in addition to the common attributes listed above):

> > Attribute | Description
> > --- | ---
> > `debug` | The debugging detail level of log messages generated by this component, with higher numbers creating more detailed output. If not specified, this attribute is set to zero (0).
> > `protocol` | This attribute value must be `AJP/1.3` to use the AJP handler.

Nested Components

> None at this time.

Configuration HOWTOs

> Please refer to the JK documentation for HOW-TOs and complete configuration information.

Copyright © 1999-2003, Apache Software Foundation